/*
this is part of brot_core.dll, a fractal generation library
Copyright (C) 2003 Rolf Neuberger

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/*
changes:
03/Mar-05 * added proper LGPL notice, started changelog - Rolf

*/

class
Generator
{
private:
	Generator();	//hide default constructor
public:
	Generator(Fractal* fractal);
	virtual ~Generator() {};

	virtual void set_fractal(Fractal* fractal) {this->fractal=fractal; reset();}
	void notify_resize();

//get some more image goodness, returns true if further refinement possible
	virtual bool refine_image(float max_time)=0;
//restart generator (does _not_ reset the fractal)
	virtual void reset()=0;
//get progress, range is [0...1]
	virtual float get_progress()=0;

	void set_preview_quality(const int maximum_step) {preview_detail=maximum_step;reset_preview();};
	void set_preview_status(bool allowed);

protected:
	Fractal* fractal;
	uint width,height;

	//generate quick and dirty preview
	bool preview(float max_time);
	void reset_preview();
	bool preview_finished;
	bool preview_enabled;

private:
	std::deque <Section> preview_data;
	int preview_detail;
	void put_fat_pixel(int x,int y,int color);
};
