/*
this is part of brot_core.dll, a fractal generation library
Copyright (C) 2003 Rolf Neuberger

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/*
changes:
03/Mar-05 * added proper LGPL notice, started changelog - Rolf

*/

//rectangular screen section

class
Section
{
public:
	short x0,y0,x1,y1;
	Section() {};
	Section(const ushort x,const short y,const short w,const short h):x0(x),y0(y),x1(x+w-1),y1(y+h-1) {};

	//split rectangle in half and return other half
	Section split() {
		Section ret(*this);			//copy constructor
		if ((x1-x0)>(y1-y0))
		{
			x1=(x0+x1)>>1;
			ret.x0=x1;
		}
		else
		{
			y1=(y0+y1)>>1;
			ret.y0=y1;
		}
		return(ret);	}

	//split rectangle horizontally, return bottom half
	Section split_horizontal()	{
		Section ret(*this);
		ret.y0=y1=(y0+y1)>>1;
		return(ret);			}

	//split rectangle vertically, return left half
	Section split_vertical()	{
		Section ret(*this);
		ret.x0=x1=(x0+x1)>>1;
		return(ret);			}

	//split, but shrink inwards by one unit
	//rectangles _must_ be at least 3 units high or wide for useful results
	//this is useful for a common mandelbrot optimization
	Section shrink_split() {
		++x0;	--x1;	++y0;	--y1;
		return(split()); }
};
