;this is part of brot_core.dll, a fractal generation library
;Copyright (C) 2003 Rolf Neuberger
;
;This library is free software; you can redistribute it and/or
;modify it under the terms of the GNU Lesser General Public
;License as published by the Free Software Foundation; either
;version 2.1 of the License, or (at your option) any later version.
;
;This library is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;Lesser General Public License for more details.
;
;You should have received a copy of the GNU Lesser General Public
;License along with this library; if not, write to the Free Software
;Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


;multiply an extremefloat by a _nonzero_ unsigned int
;prototype:
;void x86_xfloat_mul_uint(ExtremeFloat* target,uint rhs_nonzero)
_x86_xfloat_mul_uint:
	PUSHA
	MOV EDI,[byte ESP+36]
	MOV ESI,[byte ESP+40]

	MOV EAX,[byte EDI+20]	;load highest DWORD of mantissa
	TEST EAX,EAX			;is it zero?
	JZ near .early_out		;skip calculating 0.0*rhs (would yield errors too!)

	BSR ECX,ESI				;find msb
	ADD [byte EDI+24],ECX	;adjust exponent
	NEG ECX
	ADD ECX,31
	SHL ESI,CL

	MOV EAX,[EDI]			;multiply rhs*bits[0...31]
	MUL ESI					
	MOV ECX,EDX				;save high DWORD, low DWORD is discarded
	MOV EAX,[byte EDI+4]
	MUL ESI					;multiply rhs*bits[32...63]
	ADD EAX,ECX				;add old carry
	ADC EDX,0
	MOV ECX,EDX				;save high DWORD
	MOV [EDI],EAX			;write result[0...31]

	MOV EAX,[byte EDI+8]	;multiply rhs*bits[64...95]
	MUL ESI
	ADD EAX,ECX				;add old carry to low DWORD
	ADC EDX,0				;increase high DWORD on overflow
	MOV ECX,EDX				;save high DWORD
	MOV [byte EDI+4],EAX	;write result[32...63]

	MOV EAX,[byte EDI+12]	;multiply rhs*bits[96...127]
	MUL ESI
	ADD EAX,ECX				;add old carry to low DWORD
	ADC EDX,0				;increase high DWORD on overflow
	MOV ECX,EDX				;save high DWORD
	MOV [byte EDI+8],EAX	;write result[64...95]

	MOV EAX,[byte EDI+16]	;multiply rhs*bits[128...159]
	MUL ESI
	ADD EAX,ECX				;add old carry to low DWORD
	ADC EDX,0				;increase high DWORD on overflow
	MOV ECX,EDX				;save high DWORD
	MOV [byte EDI+12],EAX	;write result[96...127]

	MOV EAX,[byte EDI+20]	;multiply rhs*bits[160...191]
	MUL ESI
	ADD EAX,ECX				;add old carry to low DWORD
	ADC EDX,0				;increase high DWORD on overflow
	MOV [byte EDI+16],EAX	;write result[128...159]
	MOV [byte EDI+20],EDX	;write result[160...191]

	TEST EDX,EDX			;check MSB of result
	JNS .adjust_mantissa
	INC dword [byte EDI+24]	;increase exponent
	JMP .early_out
.adjust_mantissa:
	SHL dword [EDI],1		;shift whole mantissa one bit to the left
	RCL dword [byte EDI+4],1
	RCL dword [byte EDI+8],1
	RCL dword [byte EDI+12],1
	RCL dword [byte EDI+16],1
	RCL dword [byte EDI+20],1
.early_out:
	POPA
	RETN


;multiply an extremefloat by itself
;protoype:
;void x86_xfloat_square(ExtremeFloat* x)
_x86_xfloat_square:
	PUSH EAX
	PUSH EBX
	PUSH ECX
	PUSH EDX
	PUSH ESI
	MOV ESI,[byte ESP+24]
	MOV EBX,[byte ESI+20]		;check whether the operand is zero
	TEST EBX,EBX				;exit (0*x=0)
	JZ near .finished

	XOR EAX,EAX
	SHL dword [byte ESI+24],1	;double exponent
	MOV [byte ESI+28],EAX		;clear sign

	SUB ESP,byte 44				;allocate 352 bit temporary product

;multiply lsbs, we only need the high DWORD
	MOV EAX,[ESI]
	MOV EBX,EAX
	MUL EAX
	MOV [ESP],EDX
	MOV ECX,-5
.mul_0_loop:			;multiply remaining bits with lowest significance DWORD
	MOV EAX,EBX
	MUL dword [byte ESI+4*ECX+24]
	ADD [byte ESP+4*ECX+20],EAX
	ADC EDX,byte 0
	MOV [byte ESP+4*ECX+24],EDX
	INC ECX
	JNZ .mul_0_loop

	MOV ECX,-5
.mul_loop:
	MOV EAX,[byte ESI+4*ECX+24]
	MUL dword [byte ESI+4]
	ADD [byte ESP+4*ECX+24],EAX
	ADC [byte ESP+4*ECX+28],EDX
	SETC BL
	MOVZX EBX,BL

	MOV EAX,[byte ESI+4*ECX+24]
	MUL dword [ESI+8]
	ADD [byte ESP+4*ECX+28],EAX
	ADC EDX,EBX
	ADD [byte ESP+4*ECX+32],EDX
	SETC BL
	MOVZX EBX,BL

	MOV EAX,[byte ESI+4*ECX+24]
	MUL dword [byte ESI+12]
	ADD [byte ESP+4*ECX+32],EAX
	ADC EDX,EBX
	ADD [byte ESP+4*ECX+36],EDX
	SETC BL
	MOVZX EBX,BL

	MOV EAX,[byte ESI+4*ECX+24]
	MUL dword [byte ESI+16]
	ADD [byte ESP+4*ECX+36],EAX
	ADC EDX,EBX
	ADD [byte ESP+4*ECX+40],EDX
	SETC BL
	MOVZX EBX,BL

	MOV EAX,[byte ESI+4*ECX+24]
	MUL dword [byte ESI+20]
	ADD [byte ESP+4*ECX+40],EAX
	ADC EDX,EBX
	MOV [byte ESP+4*ECX+44],EDX
	INC ECX
	JNZ .mul_loop

	;we now have 352 bits of the product on the stack
	;the high 192 bits are the new result mantissa
	MOVQ mm0,[byte ESP+20]
	MOVQ mm1,[byte ESP+28]
	MOVQ mm2,[byte ESP+36]
	MOVQ [ESI],mm0
	MOVQ [byte ESI+8],mm1
	MOVQ [byte ESI+16],mm2
	EMMS

	;a few more bits might be needed for rounding
	;and if the msb is clear we shift everything left and need another bit
	MOV EBX,[byte ESP+16]
	ADD ESP,byte 44				;deallocate temp result
	TEST EDX,EDX
	JNS .shift

	INC dword [byte ESI+24]		;adjust exponent
	JMP .round_to_nearest
.shift:
	SHLD dword [ESI],EBX,1
	RCL dword [byte ESI+4],1
	RCL dword [byte ESI+8],1
	RCL dword [byte ESI+12],1
	RCL dword [byte ESI+16],1
	RCL dword [byte ESI+20],1
	SHL EBX,1					;we already used one bit

.round_to_nearest:
	XOR EAX,EAX
	ADD EBX,EBX					;get rounding adjustment into carry flag
	ADC [ESI],EAX
	ADC [byte ESI+4],EAX
	ADC [byte ESI+8],EAX
	ADC [byte ESI+12],EAX
	ADC [byte ESI+16],EAX
	ADC [byte ESI+20],EAX
	JS .finished
;rounding has moved the msb yet again
	RCR dword [byte ESI+20],1
	RCR dword [byte ESI+16],1
	RCR dword [byte ESI+12],1
	RCR dword [byte ESI+8],1
	RCR dword [byte ESI+4],1
	RCR dword [ESI],1
	INC dword [byte ESI+24]		;adjust exponent
.finished:
	POP ESI
	POP EDX
	POP ECX
	POP EBX
	POP EAX
	RETN

;multiply two extremefloats. assumes both operands are nonzero
;prototype:
;void x86_xfloat_mul(ExtremeFloat* target,ExtremeFloat* src)
_x86_xfloat_mul:
	PUSHA
	MOV ESI,[ESP+36]
	MOV EDI,[ESP+40]

	MOV EAX,[EDI+24]		;add exponents
	ADD [ESI+24],EAX

	MOV EAX,[EDI+28]		;adjust sign
	XOR [ESI+28],EAX

	SUB ESP,44				;allocate 352 bit temporary product
			
	MOV EAX,[EDI]			;multiply 0*0, we only need the high DWORD
	MOV EBX,EAX
	MUL dword [ESI]
	MOV [ESP],EDX
	MOV ECX,-5
.mul_0_loop:				;multiply remaining bits with lowest significance rhs' DWORD
	MOV EAX,EBX
	MUL dword [ESI+4*ECX+24]
	ADD [ESP+4*ECX+20],EAX
	ADC EDX,0
	MOV [ESP+4*ECX+24],EDX
	INC ECX
	JNZ .mul_0_loop

	MOV ECX,-5
.mul_loop:					;perform remaining 5*6 multiplies and accumulate product on stack
	MOV EAX,[ESI+4*ECX+24]
	MUL dword [EDI+4]
	ADD [ESP+4*ECX+24],EAX
	ADC [ESP+4*ECX+28],EDX
	SETC BL
	MOVZX EBX,BL

	MOV EAX,[ESI+4*ECX+24]
	MUL dword [EDI+8]
	ADD [ESP+4*ECX+28],EAX
	ADC EDX,EBX
	ADD [ESP+4*ECX+32],EDX
	SETC BL
	MOVZX EBX,BL

	MOV EAX,[ESI+4*ECX+24]
	MUL dword [EDI+12]
	ADD [ESP+4*ECX+32],EAX
	ADC EDX,EBX
	ADD [ESP+4*ECX+36],EDX
	SETC BL
	MOVZX EBX,BL

	MOV EAX,[ESI+4*ECX+24]
	MUL dword [EDI+16]
	ADD [ESP+4*ECX+36],EAX
	ADC EDX,EBX
	ADD [ESP+4*ECX+40],EDX
	SETC BL
	MOVZX EBX,BL

	MOV EAX,[ESI+4*ECX+24]
	MUL dword [EDI+20]
	ADD [ESP+4*ECX+40],EAX
	ADC EDX,EBX
	MOV [ESP+4*ECX+44],EDX
	INC ECX
	JNZ .mul_loop

	;we now have 352 bits of the product on the stack
	;the high 192 bits are the new result mantissa
	MOVQ mm0,[ESP+20]
	MOVQ mm1,[ESP+28]
	MOVQ mm2,[ESP+36]
	MOVQ [ESI],mm0
	MOVQ [ESI+8],mm1
	MOVQ [ESI+16],mm2
	EMMS

	;a few more bits might be needed for rounding
	;and if the msb is clear we shift everything left and need another bit
	MOV EDI,[ESP+16]
	ADD ESP,44					;deallocate temp result
	TEST EDX,EDX
	JNS .shift

	INC dword [ESI+24]			;adjust exponent
	JMP .round_to_nearest
.shift:
	SHLD dword [ESI],EDI,1
	RCL dword [ESI+4],1
	RCL dword [ESI+8],1
	RCL dword [ESI+12],1
	RCL dword [ESI+16],1
	RCL dword [ESI+20],1
	SHL EDI,1						;we already used one bit

.round_to_nearest:
	XOR EAX,EAX
	ADD EDI,EDI						;get rounding adjustment into carry flag
	ADC [ESI],EAX
	ADC [ESI+4],EAX
	ADC [ESI+8],EAX
	ADC [ESI+12],EAX
	ADC [ESI+16],EAX
	ADC [ESI+20],EAX
	JS .finished
;rounding has moved the msb yet again
	RCR dword [ESI+20],1
	RCR dword [ESI+16],1
	RCR dword [ESI+12],1
	RCR dword [ESI+8],1
	RCR dword [ESI+4],1
	RCR dword [ESI],1
	INC dword [ESI+24]				;adjust exponent
.finished:
	POPA
	RETN


